"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const React = require("react");
const core = require("@react-params/core");
const reactRouter = require("react-router");
const ReactRouterApiProvider = ({ children }) => {
  var _a;
  const router = (_a = React.useContext(reactRouter.UNSAFE_DataRouterContext)) == null ? void 0 : _a.router;
  const api = React.useMemo(() => {
    return {
      getSearch: () => {
        if (core.isServer && location) {
          return location.search;
        } else if (router) {
          return router.state.location.search;
        } else {
          console.error("[react-params] can't use react router context as it is not defined");
          return "";
        }
      },
      replaceState: (params, state) => {
        router == null ? void 0 : router.navigate(params, {
          replace: true,
          state
        });
      },
      pushState: (params, state) => {
        router == null ? void 0 : router.navigate(params, {
          replace: false,
          state
        });
      },
      registerListener: (listener) => {
        router == null ? void 0 : router.subscribe((action) => {
          const { state: navigationState } = action.navigation;
          if (navigationState !== "idle") {
            return;
          }
          const { state } = action.location;
          listener(state);
        });
      }
    };
  }, [router]);
  return /* @__PURE__ */ React.createElement(core.ApiContext.Provider, { value: api }, children);
};
const RemixServerApiProvider = ({ children }) => {
  const location2 = reactRouter.useLocation();
  const api = React.useMemo(() => {
    return {
      ...core.dummyApi,
      getSearch: () => {
        return location2.search;
      }
    };
  }, [location2]);
  return /* @__PURE__ */ React.createElement(core.ApiContext.Provider, { value: api }, children);
};
const RemixApiProvider = ({ children }) => {
  if (core.isServer) {
    return /* @__PURE__ */ React.createElement(RemixServerApiProvider, null, children);
  } else {
    return /* @__PURE__ */ React.createElement(ReactRouterApiProvider, null, children);
  }
};
exports.RemixApiProvider = RemixApiProvider;
//# sourceMappingURL=remix.cjs.map
